////////////////////////////////////////////////////////
//
// GEM - Graphics Environment for Multimedia
//
// zmoelnig@iem.kug.ac.at
//
// Implementation file
//
//    Copyright (c) 1997-2000 Mark Danks.
//    Copyright (c) Gnther Geiger.
//    Copyright (c) 2001-2002 IOhannes m zmoelnig. forum::fr::umlute. IEM
//    For information on usage and redistribution, and for a DISCLAIMER OF ALL
//    WARRANTIES, see the file, "GEM.LICENSE.TERMS" in this distribution.
//
/////////////////////////////////////////////////////////

#include "teapot.h"

CPPEXTERN_NEW_WITH_ONE_ARG(teapot, t_floatarg, A_DEFFLOAT)

/////////////////////////////////////////////////////////
//
// teapot
//
/////////////////////////////////////////////////////////
// Constructor
//
/////////////////////////////////////////////////////////
teapot :: teapot(t_floatarg size)
      : GemGlutObj(size)
{ }

/////////////////////////////////////////////////////////
// Destructor
//
/////////////////////////////////////////////////////////
teapot :: ~teapot()
{ }

/////////////////////////////////////////////////////////
// render
//
/////////////////////////////////////////////////////////
void teapot :: render(GemState *state)
{
	glPushMatrix();
	glRotatef(180.f, 1.f, 0.f, 0.f);
	glutSolidTeapot(-m_size);
	glPopMatrix();
}

/////////////////////////////////////////////////////////
// static member functions
//
/////////////////////////////////////////////////////////
void teapot :: obj_setupCallback(t_class *)
{ }
